#!/bin/tcsh -f 

# Simple shell script to analyze data from the program rw1.c
# To see data run as:
# % cc -O2 rw1.c -o rw1
# % rw1-anal.csh > rw1-anal.out
# % grep ^R2 rw1-anal.out
# % grep ^n  rw1-anal.out
# etc. etc.
# To plot results:
# % gnuplot
# gnuplot> plot "<grep ^R2 rw1-anal.out" using 2:3:5 title "R2"
# gnuplot> plot "<grep ^n  rw1-anal.out" using 2:3:5 title "n"
set Nwalk = 1000
set Ns    = (16 32 64 128 256 512 1024 2048 4096 8192 16384 \
             32768 65536 131072)

foreach N ($Ns)
 ./rw1 $Nwalk $N > rwalk.$N.dat
 echo -n "R2  $N  " # Compute 
 grep ^R rwalk.$N.dat | awk '{print $3}' | ./average
 echo -n "x   $N  "
 grep ^R rwalk.$N.dat | awk '{print $4}' | ./average
 echo -n "y   $N  "
 grep ^R rwalk.$N.dat | awk '{print $5}' | ./average
 echo -n "n   $N  "
 grep ^R rwalk.$N.dat | awk '{print $6}' | ./average
end
