/* padd = 1 - exp(-2*beta*J)
 */

#include "include.h"

void wolff(){

  int i,sp,oldspin,newspin,current,nn;
  int *stack;
  int ncluster;

  /*ask for the stack memory*/
  stack = (int *)malloc((size_t)(N*sizeof(int)));
  if(!stack)locerr("allocation failure for stack in wolff()");

  /*choose the seed  spin for the cluster, put it on the stack and flip it */
  i=N*drandom();
  stack[0]=i;
  sp=1;
  oldspin  =  s[i];
  newspin  = -s[i];
  s[i]     = newspin;
  ncluster = 1;
  /*start loop on spins on the stack: */
  while(sp){
    /*Pull a site off the stack */
    current = stack[--sp];//value of --sp is **after** decrement
    /*check neighbours*/
    if((nn=current+XNN)>=N) nn -= N;
    if(s[nn] == oldspin)
      if(drandom()<padd){
	stack[sp++] = nn;//value of sp++ is **before** increment
	s[nn] = newspin; //flip the spin of cluster
	ncluster++;
      }
    if((nn=current-XNN)<0) nn += N;
    if(s[nn] == oldspin)
      if(drandom()<padd){
	stack[sp++] = nn;//value of sp++ is **before** increment
	s[nn] = newspin; //flip the spin of cluster
	ncluster++;
      }
    if((nn=current+YNN)>=N) nn -= N;
    if(s[nn] == oldspin)
      if(drandom()<padd){
	stack[sp++] = nn;//value of sp++ is **before** increment
	s[nn] = newspin; //flip the spin of cluster
	ncluster++;
      }
    if((nn=current-YNN)<0) nn += N;
    if(s[nn] == oldspin)
      if(drandom()<padd){
	stack[sp++] = nn;//value of sp++ is **before** increment
	s[nn] = newspin; //flip the spin of cluster
	ncluster++;
      }

  }/*while(sp)*/
  printf("#clu %d\n",ncluster);
  free(stack);
}/*wolff()*/
