#!/bin/tcsh -f 

set Ls = (10 20 40 60 80 100)
set b  = 0.4407

# Wolff
set tmax  = 1000
set ndata = 5005000
foreach L ($Ls)
 set f = outL${L}b${b}
 if( ! -f $f) goto skip_L
 grep -v '#' $f | \
 awk -v L=$L 'BEGIN{N=L*L}NR>100000{print  ($2>0)?($2/N):(-$2/N)}'|\
 ./autoc -t $tmax -n $ndata> $f.rhom
skip_L:
end

# Metropolis
set tmax  = 8000
set ndata = 10020000
foreach L ($Ls)
 set f = outL${L}b${b}met
 if( ! -f $f) goto skip_L
 grep -v '#' $f | \
 awk -v L=$L 'BEGIN{N=L*L}NR>100000{print  ($2>0)?($2/N):(-$2/N)}'|\
 ./autoc -t $tmax  -n $ndata> $f.rhom
skip_L:
end

