/* Header file to be used when functions defined in nrutil-ext.c
 * are used. Contains extensions of useful functions defined in
 * the recipes utilities file nrutil.c
    In particular:
    d3tensor, free_d3tensor: double 3 tensor
    d4tensor, free_d4tensor: double 4 tensor
    cdvector,civector,cdmatrix,cimatrix,cd3tensor,cd4tensor: Arrays initialized to 0
    zero_dvector ,zero_ivector,zero_dmatrix,zero_imatrix,
    zero_d3vector,zero_d4tensor: Put elem. of arrays =0
 * K. Anagnostopoulos, NBI Jan 1996
 */

/* File will not be reread since the macro _NR_UTILS_H_ is defined */
#include "nrutil.h"

/* include the file only once */
#ifndef _NR_UTILS_H_EXT_
#define _NR_UTILS_H_EXT_

long        *slvector(long nl , long nh );
void        free_slvector(long nl , long nh );
double   ***d3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh);
double  ***cd3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh);
double  ****d4tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh,
		     long nwl, long nwh);
double ****cd4tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh,
		     long nwl, long nwh);
double     *cdvector(long nl , long nh );
int        *civector(long nl , long nh );
double    **cdmatrix(long nrl, long nrh, long ncl, long nch);
int       **cimatrix(long nrl, long nrh, long ncl, long nch);

void free_d3tensor(double  ***t, long nrl, long nrh, long ncl, long nch,
	long ndl, long ndh);
void free_d4tensor(double ****t, long nrl, long nrh, long ncl, long nch,
	long ndl, long ndh,long nwl, long nwh);

void zero_dvector(double *v, long nl, long nh);
void zero_ivector(int *v, long nl, long nh);
void zero_dmatrix(double **v, long nrl, long nrh, long ncl, long nch);
void zero_imatrix(int **v, long nrl, long nrh, long ncl, long nch);
void zero_d3tensor(double ***v, long nrl, long nrh, long ncl, long nch, 
		   long ndl, long ndh);
void zero_d4tensor(double ****v, long nrl, long nrh, long ncl, long nch, 
		   long ndl, long ndh, long nwl, long nwh);

#endif /* _NR_UTILS_H_EXT_ */
